unit RotateUnit;    
                                                        
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, cad, ComCtrls,ShellAPI;

type
  TRotateFrm = class(TForm)
    Timer1: TTimer;
    PlayBtn: TBitBtn;
    CloseBtn: TBitBtn;
    StopBtn: TBitBtn;
    Bevel1: TBevel;                       
    Label3: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    MyCAD1: TMyCAD;
    Label4: TLabel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure PlayBtnClick(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure Label4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  RotateFrm: TRotateFrm;


  Step :double = 6*pi/180;
implementation



{$R *.dfm}

procedure TRotateFrm.FormShow(Sender: TObject);
var
myBitmap:TBitmap;
begin
 if MyCAD1.GetShapesCount >1 then Exit;
 {Create a temp bitmap to load form a disk file}
 MyBitmap := TBitmap.Create;

      {Load from files}
      Mybitmap.LoadFromFile( ExtractFilePath(Application.ExeName) +'images\1'+'.bmp');

      {a layer0 already exist by default}
      {Add Image into TMyCAD by code}
      MyCAD1.AddImageShapeByCode('MyImage',Point(50,100),MyBitmap);

      MyCAD1.AddShapeByCode(MyCAD1,spEllipse,'EllipseName',[MyPoint(20,80),MyPoint(80,80),MyPoint(80,160),MyPoint(20,160)],0);

  {free it because no use}
 MyBitmap.Free;

 {do not show  a hot region}
 MyCAD1.DeSelectedAllShapesByCode;

end;


procedure TRotateFrm.Timer1Timer(Sender: TObject);
var
 i:integer;
 AShape:TMyShape;

begin
  for i:= 0 to  MyCAD1.GetShapesCount -1 do
  begin
      AShape:=MyCAD1.GetShapeByID(i);
      if AShape <> nil then
         MyCAD1.Rotate(AShape,Step);
  end;
end;

procedure TRotateFrm.PlayBtnClick(Sender: TObject);
begin
  Timer1.Enabled:=true;
end;

procedure TRotateFrm.StopBtnClick(Sender: TObject);
begin
  Timer1.Enabled:=false;
end;

procedure TRotateFrm.Label4Click(Sender: TObject);
begin
ShellExecute(handle, 'open','http://www.codeidea.com', nil, nil, SW_SHOWNORMAL);
end;

procedure TRotateFrm.Button1Click(Sender: TObject);
begin
{Draw A rectangle}
MyCAD1.ShapeTool:=SpRectangle;
end;

procedure TRotateFrm.TrackBar2Change(Sender: TObject);
begin
 
 Step:=TrackBar2.Position * pi/180;
end;

procedure TRotateFrm.TrackBar1Change(Sender: TObject);
begin
 Timer1.Interval:=TrackBar1.Position;
end;

procedure TRotateFrm.CloseBtnClick(Sender: TObject);
begin
  Timer1.Enabled:=false;
  close;
end;

procedure TRotateFrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Timer1.Enabled:=false;
end;

end.
